﻿//---------------------------------------------------------------------
// <copyright file="Microsoft.OData.Service.cs" company="Microsoft">
//      Copyright (C) Microsoft Corporation. All rights reserved. See License.txt in the project root for license information.
//
//      GENERATED FILE.  DO NOT MODIFY.
//
// </copyright>
//---------------------------------------------------------------------

namespace Microsoft.OData.Service {
    using System;
    using System.Globalization;
    using System.Reflection;
    using System.Resources;
    using System.Security.Permissions;
    using System.Text;
    using System.Threading;
    using System.ComponentModel;

    [AttributeUsage(AttributeTargets.All)]
    internal sealed class TextResDescriptionAttribute : DescriptionAttribute {

        private bool replaced = false;

        /// <summary>
        ///     Constructs a new sys description.
        /// </summary>
        /// <param name='description'>
        ///     description text.
        /// </param>
        public TextResDescriptionAttribute(string description) : base(description) {
        }

        /// <summary>
        ///     Retrieves the description text.
        /// </summary>
        /// <returns>
        ///     description
        /// </returns>
        public override string Description {
            get {
                if (!replaced) {
                    replaced = true;
                    DescriptionValue = TextRes.GetString(base.Description);
                }
                return base.Description;
            }
        }
    }

    [AttributeUsage(AttributeTargets.All)]
    internal sealed class TextResCategoryAttribute : CategoryAttribute {

        public TextResCategoryAttribute(string category) : base(category) {
        }

        protected override string GetLocalizedString(string value) {
            return TextRes.GetString(value);
        }
    }

    /// <summary>
    ///    AutoGenerated resource class. Usage:
    ///
    ///        string s = TextRes.GetString(TextRes.MyIdentifier);
    /// </summary>
    internal sealed class TextRes {
        internal const string ALinq_UnsupportedExpression = "ALinq_UnsupportedExpression";
        internal const string InvalidEnumValue = "InvalidEnumValue";
        internal const string OpenNavigationPropertiesNotSupportedOnOpenTypes = "OpenNavigationPropertiesNotSupportedOnOpenTypes";
        internal const string BaseServiceProvider_IEnumerableAlwaysMultiple = "BaseServiceProvider_IEnumerableAlwaysMultiple";
        internal const string BaseServiceProvider_OverloadingNotSupported = "BaseServiceProvider_OverloadingNotSupported";
        internal const string BaseServiceProvider_ParameterNotIn = "BaseServiceProvider_ParameterNotIn";
        internal const string BaseServiceProvider_ParameterTypeNotSupported = "BaseServiceProvider_ParameterTypeNotSupported";
        internal const string BaseServiceProvider_ServiceOperationMissingSingleEntitySet = "BaseServiceProvider_ServiceOperationMissingSingleEntitySet";
        internal const string BaseServiceProvider_UnsupportedReturnType = "BaseServiceProvider_UnsupportedReturnType";
        internal const string BaseServiceProvider_UnknownResourceTypeInstance = "BaseServiceProvider_UnknownResourceTypeInstance";
        internal const string BasicExpandProvider_ExpandedPropertiesNotInitialized = "BasicExpandProvider_ExpandedPropertiesNotInitialized";
        internal const string BasicExpandProvider_ProjectedPropertiesNotInitialized = "BasicExpandProvider_ProjectedPropertiesNotInitialized";
        internal const string BasicExpandProvider_UnsupportedExpandBreadth = "BasicExpandProvider_UnsupportedExpandBreadth";
        internal const string BasicExpandProvider_SDP_UnsupportedOrderingExpressionBreadth = "BasicExpandProvider_SDP_UnsupportedOrderingExpressionBreadth";
        internal const string BasicExpandProvider_ExpandNotSupportedForOpenProperties = "BasicExpandProvider_ExpandNotSupportedForOpenProperties";
        internal const string CallbackQueryOptionHandler_UnsupportedContentType = "CallbackQueryOptionHandler_UnsupportedContentType";
        internal const string CallbackQueryOptionHandler_GetRequestsOnly = "CallbackQueryOptionHandler_GetRequestsOnly";
        internal const string DataServiceActionProviderWrapper_ServiceActionBindingParameterNull = "DataServiceActionProviderWrapper_ServiceActionBindingParameterNull";
        internal const string DataServiceActionProviderWrapper_ResourceTypeMustBeAssignableToBindingParameterResourceType = "DataServiceActionProviderWrapper_ResourceTypeMustBeAssignableToBindingParameterResourceType";
        internal const string DataServiceActionProviderWrapper_AdvertiseServiceActionCannotReturnNullActionToSerialize = "DataServiceActionProviderWrapper_AdvertiseServiceActionCannotReturnNullActionToSerialize";
        internal const string DataServiceProviderWrapper_ResourceContainerNotReadonly = "DataServiceProviderWrapper_ResourceContainerNotReadonly";
        internal const string DataServiceProviderWrapper_ResourceTypeNotReadonly = "DataServiceProviderWrapper_ResourceTypeNotReadonly";
        internal const string DataServiceProviderWrapper_ServiceOperationNotReadonly = "DataServiceProviderWrapper_ServiceOperationNotReadonly";
        internal const string DataServiceProviderWrapper_ContainerNamespaceMustNotBeNullOrEmpty = "DataServiceProviderWrapper_ContainerNamespaceMustNotBeNullOrEmpty";
        internal const string DataServiceProviderWrapper_ContainerNameMustNotBeNullOrEmpty = "DataServiceProviderWrapper_ContainerNameMustNotBeNullOrEmpty";
        internal const string DataServiceProviderWrapper_DataSourceTypeMustBeAssignableToContextType = "DataServiceProviderWrapper_DataSourceTypeMustBeAssignableToContextType";
        internal const string DataServiceProviderWrapper_MultipleEntitySetsWithSameName = "DataServiceProviderWrapper_MultipleEntitySetsWithSameName";
        internal const string DataServiceProviderWrapper_MultipleResourceTypesWithSameName = "DataServiceProviderWrapper_MultipleResourceTypesWithSameName";
        internal const string DataServiceProviderWrapper_MultipleServiceOperationsWithSameName = "DataServiceProviderWrapper_MultipleServiceOperationsWithSameName";
        internal const string DataServiceProviderWrapper_CollectionOfComplexTypeWithDerivedTypes = "DataServiceProviderWrapper_CollectionOfComplexTypeWithDerivedTypes";
        internal const string DataServiceProviderWrapper_InvalidQueryRootType = "DataServiceProviderWrapper_InvalidQueryRootType";
        internal const string DataServiceProviderWrapper_AnnotationsBuilderCannotReturnNullModels = "DataServiceProviderWrapper_AnnotationsBuilderCannotReturnNullModels";
        internal const string DataServiceProviderWrapper_ActionHasNoBindableSet = "DataServiceProviderWrapper_ActionHasNoBindableSet";
        internal const string DataServiceProviderWrapper_ActionHasNoVisibleSetReachableFromPathExpression = "DataServiceProviderWrapper_ActionHasNoVisibleSetReachableFromPathExpression";
        internal const string DataServiceActionProviderWrapper_DuplicateAction = "DataServiceActionProviderWrapper_DuplicateAction";
        internal const string DataServiceProviderBehavior_ProviderBehaviorMustBeNonNull = "DataServiceProviderBehavior_ProviderBehaviorMustBeNonNull";
        internal const string ErrorHandler_ErrorWhileWritingError = "ErrorHandler_ErrorWhileWritingError";
        internal const string ETagAttribute_MustSpecifyAtleastOnePropertyName = "ETagAttribute_MustSpecifyAtleastOnePropertyName";
        internal const string ExpandSegment_FilterShouldBeLambda = "ExpandSegment_FilterShouldBeLambda";
        internal const string ExpandSegment_FilterBodyShouldReturnBool = "ExpandSegment_FilterBodyShouldReturnBool";
        internal const string ExpandSegment_FilterBodyShouldTakeOneParameter = "ExpandSegment_FilterBodyShouldTakeOneParameter";
        internal const string HttpContextServiceHost_AmbiguousItemName = "HttpContextServiceHost_AmbiguousItemName";
        internal const string HttpContextServiceHost_WebOperationContextCurrentMissing = "HttpContextServiceHost_WebOperationContextCurrentMissing";
        internal const string HttpContextServiceHost_IncomingTemplateMatchFragment = "HttpContextServiceHost_IncomingTemplateMatchFragment";
        internal const string HttpContextServiceHost_IncomingTemplateMatchQuery = "HttpContextServiceHost_IncomingTemplateMatchQuery";
        internal const string HttpContextServiceHost_MalformedHeaderValue = "HttpContextServiceHost_MalformedHeaderValue";
        internal const string HttpContextServiceHost_XMethodIncorrectCount = "HttpContextServiceHost_XMethodIncorrectCount";
        internal const string HttpContextServiceHost_XMethodIncorrectValue = "HttpContextServiceHost_XMethodIncorrectValue";
        internal const string HttpContextServiceHost_XMethodNotUsingPost = "HttpContextServiceHost_XMethodNotUsingPost";
        internal const string HttpContextServiceHost_QueryParameterMustBeSpecifiedOnce = "HttpContextServiceHost_QueryParameterMustBeSpecifiedOnce";
        internal const string HttpContextServiceHost_UnknownQueryParameter = "HttpContextServiceHost_UnknownQueryParameter";
        internal const string HttpContextServiceHost_IncomingMessagePropertyMustBeValidUriInstance = "HttpContextServiceHost_IncomingMessagePropertyMustBeValidUriInstance";
        internal const string HttpProcessUtility_ContentTypeMissing = "HttpProcessUtility_ContentTypeMissing";
        internal const string HttpProcessUtility_MediaTypeMissingValue = "HttpProcessUtility_MediaTypeMissingValue";
        internal const string HttpProcessUtility_MediaTypeRequiresSemicolonBeforeParameter = "HttpProcessUtility_MediaTypeRequiresSemicolonBeforeParameter";
        internal const string HttpProcessUtility_MediaTypeRequiresSlash = "HttpProcessUtility_MediaTypeRequiresSlash";
        internal const string HttpProcessUtility_MediaTypeRequiresSubType = "HttpProcessUtility_MediaTypeRequiresSubType";
        internal const string HttpProcessUtility_MediaTypeUnspecified = "HttpProcessUtility_MediaTypeUnspecified";
        internal const string HttpProcessUtility_EncodingNotSupported = "HttpProcessUtility_EncodingNotSupported";
        internal const string HttpProcessUtility_EscapeCharWithoutQuotes = "HttpProcessUtility_EscapeCharWithoutQuotes";
        internal const string HttpProcessUtility_EscapeCharAtEnd = "HttpProcessUtility_EscapeCharAtEnd";
        internal const string HttpProcessUtility_ClosingQuoteNotFound = "HttpProcessUtility_ClosingQuoteNotFound";
        internal const string IgnorePropertiesAttribute_PropertyNameCannotBeNullOrEmpty = "IgnorePropertiesAttribute_PropertyNameCannotBeNullOrEmpty";
        internal const string IgnorePropertiesAttribute_InvalidPropertyName = "IgnorePropertiesAttribute_InvalidPropertyName";
        internal const string PlainXml_IncorrectElementName = "PlainXml_IncorrectElementName";
        internal const string RequestQueryParser_DigitExpected = "RequestQueryParser_DigitExpected";
        internal const string RequestQueryParser_DisallowMemberAccessForResourceSetReference = "RequestQueryParser_DisallowMemberAccessForResourceSetReference";
        internal const string RequestQueryParser_ExpressionTypeMismatch = "RequestQueryParser_ExpressionTypeMismatch";
        internal const string RequestQueryParser_IdentifierExpected = "RequestQueryParser_IdentifierExpected";
        internal const string RequestQueryParser_IncompatibleOperand = "RequestQueryParser_IncompatibleOperand";
        internal const string RequestQueryParser_IncompatibleOperands = "RequestQueryParser_IncompatibleOperands";
        internal const string RequestQueryParser_InvalidCharacter = "RequestQueryParser_InvalidCharacter";
        internal const string RequestQueryParser_NoApplicableFunction = "RequestQueryParser_NoApplicableFunction";
        internal const string RequestQueryParser_NotDoesNotSupportType = "RequestQueryParser_NotDoesNotSupportType";
        internal const string RequestQueryParser_NullOperatorUnsupported = "RequestQueryParser_NullOperatorUnsupported";
        internal const string RequestQueryParser_OrderByDoesNotSupportType = "RequestQueryParser_OrderByDoesNotSupportType";
        internal const string RequestQueryParser_SyntaxError = "RequestQueryParser_SyntaxError";
        internal const string RequestQueryParser_UnknownFunction = "RequestQueryParser_UnknownFunction";
        internal const string RequestQueryParser_UnrecognizedLiteral = "RequestQueryParser_UnrecognizedLiteral";
        internal const string RequestQueryParser_UnterminatedLiteral = "RequestQueryParser_UnterminatedLiteral";
        internal const string RequestQueryParser_UnterminatedStringLiteral = "RequestQueryParser_UnterminatedStringLiteral";
        internal const string RequsetQueryParser_ExpectingLiteralInSkipToken = "RequsetQueryParser_ExpectingLiteralInSkipToken";
        internal const string RequestQueryParser_AllWithoutAPredicateIsNotSupported = "RequestQueryParser_AllWithoutAPredicateIsNotSupported";
        internal const string RequestQueryParser_SpatialNotSupported = "RequestQueryParser_SpatialNotSupported";
        internal const string RequestQueryParser_InvalidNumericString = "RequestQueryParser_InvalidNumericString";
        internal const string RequestQueryProcessor_IncorrectArgumentFormat = "RequestQueryProcessor_IncorrectArgumentFormat";
        internal const string RequestQueryProcessor_QueryExpandOptionNotApplicable = "RequestQueryProcessor_QueryExpandOptionNotApplicable";
        internal const string RequestQueryProcessor_QueryFilterOptionNotApplicable = "RequestQueryProcessor_QueryFilterOptionNotApplicable";
        internal const string RequestQueryProcessor_FormatNotApplicable = "RequestQueryProcessor_FormatNotApplicable";
        internal const string RequestQueryProcessor_QueryNoOptionsApplicable = "RequestQueryProcessor_QueryNoOptionsApplicable";
        internal const string RequestQueryProcessor_QuerySetOptionsNotApplicable = "RequestQueryProcessor_QuerySetOptionsNotApplicable";
        internal const string RequestQueryProcessor_QuerySelectOptionNotApplicable = "RequestQueryProcessor_QuerySelectOptionNotApplicable";
        internal const string RequestQueryProcessor_InvalidCountOptionError = "RequestQueryProcessor_InvalidCountOptionError";
        internal const string RequestQueryProcessor_RequestVerbCannotCountError = "RequestQueryProcessor_RequestVerbCannotCountError";
        internal const string RequestQueryProcessor_QueryCountWithSegmentCount = "RequestQueryProcessor_QueryCountWithSegmentCount";
        internal const string RequestQueryProcessor_PrimitivePropertyUsedAsNavigationProperty = "RequestQueryProcessor_PrimitivePropertyUsedAsNavigationProperty";
        internal const string RequestQueryProcessor_ComplexPropertyAsInnerSelectSegment = "RequestQueryProcessor_ComplexPropertyAsInnerSelectSegment";
        internal const string RequestQueryProcessor_CollectionPropertyAsInnerSelectSegment = "RequestQueryProcessor_CollectionPropertyAsInnerSelectSegment";
        internal const string RequestQueryProcessor_ProjectedPropertyWithoutMatchingExpand = "RequestQueryProcessor_ProjectedPropertyWithoutMatchingExpand";
        internal const string RequestQueryProcessor_SkipTokenSupportedOnPagedSets = "RequestQueryProcessor_SkipTokenSupportedOnPagedSets";
        internal const string RequestQueryProcessor_SkipTokenNotAllowed = "RequestQueryProcessor_SkipTokenNotAllowed";
        internal const string RequestQueryProcessor_NamedStreamMustBeLastSegmentInSelect = "RequestQueryProcessor_NamedStreamMustBeLastSegmentInSelect";
        internal const string RequestQueryProcessor_ServiceActionMustBeLastSegmentInSelect = "RequestQueryProcessor_ServiceActionMustBeLastSegmentInSelect";
        internal const string RequestQueryProcessor_SelectAndExpandCannotBeSpecifiedTogether = "RequestQueryProcessor_SelectAndExpandCannotBeSpecifiedTogether";
        internal const string RequestQueryProcessor_CannotSpecifyOpenPropertyAndDeclaredPropertyAtTheSameTime = "RequestQueryProcessor_CannotSpecifyOpenPropertyAndDeclaredPropertyAtTheSameTime";
        internal const string RequestQueryProcessor_QueryParametersPathCannotEndInTypeIdentifier = "RequestQueryProcessor_QueryParametersPathCannotEndInTypeIdentifier";
        internal const string RequestUriProcessor_AbsoluteRequestUriCannotBeNull = "RequestUriProcessor_AbsoluteRequestUriCannotBeNull";
        internal const string RequestUriProcessor_AbsoluteRequestUriMustBeAbsolute = "RequestUriProcessor_AbsoluteRequestUriMustBeAbsolute";
        internal const string RequestUriProcessor_AbsoluteServiceUriCannotBeNull = "RequestUriProcessor_AbsoluteServiceUriCannotBeNull";
        internal const string RequestUriProcessor_AbsoluteServiceUriMustBeAbsolute = "RequestUriProcessor_AbsoluteServiceUriMustBeAbsolute";
        internal const string RequestUriProcessor_Forbidden = "RequestUriProcessor_Forbidden";
        internal const string RequestUriProcessor_KeysMustBeNamed = "RequestUriProcessor_KeysMustBeNamed";
        internal const string RequestUriProcessor_MethodNotAllowed = "RequestUriProcessor_MethodNotAllowed";
        internal const string RequestUriProcessor_PropertyNotFound = "RequestUriProcessor_PropertyNotFound";
        internal const string RequestUriProcessor_ResourceNotFound = "RequestUriProcessor_ResourceNotFound";
        internal const string RequestUriProcessor_SyntaxError = "RequestUriProcessor_SyntaxError";
        internal const string RequestUriProcessor_EmptySegmentInRequestUrl = "RequestUriProcessor_EmptySegmentInRequestUrl";
        internal const string RequestUriProcessor_ValueSegmentAfterScalarPropertySegment = "RequestUriProcessor_ValueSegmentAfterScalarPropertySegment";
        internal const string RequestUriProcessor_IEnumerableServiceOperationsCannotBeFurtherComposed = "RequestUriProcessor_IEnumerableServiceOperationsCannotBeFurtherComposed";
        internal const string RequestUriProcessor_CannotQueryCollections = "RequestUriProcessor_CannotQueryCollections";
        internal const string RequestUriProcessor_MustBeLeafSegment = "RequestUriProcessor_MustBeLeafSegment";
        internal const string RequestUriProcessor_LinkSegmentMustBeFollowedByEntitySegment = "RequestUriProcessor_LinkSegmentMustBeFollowedByEntitySegment";
        internal const string RequestUriProcessor_CannotSpecifyAfterPostLinkSegment = "RequestUriProcessor_CannotSpecifyAfterPostLinkSegment";
        internal const string RequestUriProcessor_CountOnRoot = "RequestUriProcessor_CountOnRoot";
        internal const string RequestUriProcessor_CountNotSupported = "RequestUriProcessor_CountNotSupported";
        internal const string RequestUriProcessor_InvalidHttpMethodForNamedStream = "RequestUriProcessor_InvalidHttpMethodForNamedStream";
        internal const string RequestUriProcessor_SegmentDoesNotSupportKeyPredicates = "RequestUriProcessor_SegmentDoesNotSupportKeyPredicates";
        internal const string RequestUriProcessor_InvalidTypeIdentifier_MustBeASubType = "RequestUriProcessor_InvalidTypeIdentifier_MustBeASubType";
        internal const string RequestUriProcessor_InvalidTypeIdentifier_UnrelatedType = "RequestUriProcessor_InvalidTypeIdentifier_UnrelatedType";
        internal const string RequestUriProcessor_TypeIdentifierCannotBeSpecifiedAfterTypeIdentifier = "RequestUriProcessor_TypeIdentifierCannotBeSpecifiedAfterTypeIdentifier";
        internal const string RequestUriProcessor_UnbindableOperationsMustBeCalledAtRootLevel = "RequestUriProcessor_UnbindableOperationsMustBeCalledAtRootLevel";
        internal const string RequestUriProcessor_MissingBindingParameter = "RequestUriProcessor_MissingBindingParameter";
        internal const string RequestUriProcessor_BindingParameterNotAssignableFromPreviousSegment = "RequestUriProcessor_BindingParameterNotAssignableFromPreviousSegment";
        internal const string RequestUriProcessor_BatchedActionOnEntityCreatedInSameChangeset = "RequestUriProcessor_BatchedActionOnEntityCreatedInSameChangeset";
        internal const string RequestUriProcessor_ActionComposedWithWebInvokeServiceOperationNotAllowed = "RequestUriProcessor_ActionComposedWithWebInvokeServiceOperationNotAllowed";
        internal const string PathParser_EntityReferenceNotSupported = "PathParser_EntityReferenceNotSupported";
        internal const string PathParser_ServiceOperationsWithSameName = "PathParser_ServiceOperationsWithSameName";
        internal const string ResourceContainer_ContainerMustBeAssociatedWithEntityType = "ResourceContainer_ContainerMustBeAssociatedWithEntityType";
        internal const string ResourceSet_Sealed = "ResourceSet_Sealed";
        internal const string ResourceSetPathExpression_PathExpressionMustStartWithBindingParameterName = "ResourceSetPathExpression_PathExpressionMustStartWithBindingParameterName";
        internal const string ResourceSetPathExpression_PropertyNotFound = "ResourceSetPathExpression_PropertyNotFound";
        internal const string ResourceSetPathExpression_PropertyMustBeEntityType = "ResourceSetPathExpression_PropertyMustBeEntityType";
        internal const string ResourceSetPathExpression_PathCannotEndWithTypeIdentifier = "ResourceSetPathExpression_PathCannotEndWithTypeIdentifier";
        internal const string ResourceSetPathExpression_EmptySegment = "ResourceSetPathExpression_EmptySegment";
        internal const string ResourceType_NoKeysInDerivedTypes = "ResourceType_NoKeysInDerivedTypes";
        internal const string ResourceType_KeyPropertiesOnlyOnEntityTypes = "ResourceType_KeyPropertiesOnlyOnEntityTypes";
        internal const string ResourceType_ETagPropertiesOnlyOnEntityTypes = "ResourceType_ETagPropertiesOnlyOnEntityTypes";
        internal const string ResourceType_InvalidValueForResourceTypeKind = "ResourceType_InvalidValueForResourceTypeKind";
        internal const string ResourceType_TypeCannotBeValueType = "ResourceType_TypeCannotBeValueType";
        internal const string ResourceType_Sealed = "ResourceType_Sealed";
        internal const string ResourceType_MissingKeyPropertiesForEntity = "ResourceType_MissingKeyPropertiesForEntity";
        internal const string ResourceType_NamedStreamsOnlyApplyToEntityType = "ResourceType_NamedStreamsOnlyApplyToEntityType";
        internal const string ResourceType_PropertyWithSameNameAlreadyExists = "ResourceType_PropertyWithSameNameAlreadyExists";
        internal const string ResourceType_ComplexTypeCannotBeOpen = "ResourceType_ComplexTypeCannotBeOpen";
        internal const string ResourceType_CollectionItemCanBeOnlyPrimitiveOrComplex = "ResourceType_CollectionItemCanBeOnlyPrimitiveOrComplex";
        internal const string ResourceType_CollectionItemCanBeOnlyEntity = "ResourceType_CollectionItemCanBeOnlyEntity";
        internal const string ResourceType_InvalidResourceTypeKindInheritance = "ResourceType_InvalidResourceTypeKindInheritance";
        internal const string ResourceType_CollectionItemCannotBeStream = "ResourceType_CollectionItemCannotBeStream";
        internal const string ResourceType_SpatialKeyOrETag = "ResourceType_SpatialKeyOrETag";
        internal const string ResourceProperty_Sealed = "ResourceProperty_Sealed";
        internal const string ResourceProperty_MimeTypeAttributeEmpty = "ResourceProperty_MimeTypeAttributeEmpty";
        internal const string ResourceProperty_MimeTypeAttributeOnNonPrimitive = "ResourceProperty_MimeTypeAttributeOnNonPrimitive";
        internal const string ResourceProperty_MimeTypeNotValid = "ResourceProperty_MimeTypeNotValid";
        internal const string ResourceProperty_PropertyKindAndResourceTypeKindMismatch = "ResourceProperty_PropertyKindAndResourceTypeKindMismatch";
        internal const string ResourceProperty_KeyPropertiesCannotBeNullable = "ResourceProperty_KeyPropertiesCannotBeNullable";
        internal const string ResourceProperty_NamedStreamCannotReflect = "ResourceProperty_NamedStreamCannotReflect";
        internal const string ResourceProperty_NamedStreamKindMustBeUsedAlone = "ResourceProperty_NamedStreamKindMustBeUsedAlone";
        internal const string Serializer_CannotConvertValue = "Serializer_CannotConvertValue";
        internal const string Serializer_NullKeysAreNotSupported = "Serializer_NullKeysAreNotSupported";
        internal const string Serializer_ResultsExceedMax = "Serializer_ResultsExceedMax";
        internal const string Serializer_UnsupportedTopLevelType = "Serializer_UnsupportedTopLevelType";
        internal const string Serializer_ETagValueDoesNotMatch = "Serializer_ETagValueDoesNotMatch";
        internal const string Serializer_NoETagPropertiesForType = "Serializer_NoETagPropertiesForType";
        internal const string Serializer_CollectionCanNotBeNull = "Serializer_CollectionCanNotBeNull";
        internal const string Serializer_CollectionPropertyValueMustImplementIEnumerable = "Serializer_CollectionPropertyValueMustImplementIEnumerable";
        internal const string Serializer_LoopsNotAllowedInComplexTypes = "Serializer_LoopsNotAllowedInComplexTypes";
        internal const string ServiceOperation_MimeTypeNotValid = "ServiceOperation_MimeTypeNotValid";
        internal const string ServiceOperation_MimeTypeCannotBeEmpty = "ServiceOperation_MimeTypeCannotBeEmpty";
        internal const string ServiceOperation_Sealed = "ServiceOperation_Sealed";
        internal const string ServiceOperation_ResultTypeAndKindMustMatch = "ServiceOperation_ResultTypeAndKindMustMatch";
        internal const string ServiceOperation_ResultSetMustBeNullForGivenResultType = "ServiceOperation_ResultSetMustBeNullForGivenResultType";
        internal const string ServiceOperation_ResultSetMustBeNullForGivenReturnType = "ServiceOperation_ResultSetMustBeNullForGivenReturnType";
        internal const string ServiceOperation_ResultTypeAndResultSetMustMatch = "ServiceOperation_ResultTypeAndResultSetMustMatch";
        internal const string ServiceOperation_ReturnTypeAndResultSetMustMatch = "ServiceOperation_ReturnTypeAndResultSetMustMatch";
        internal const string ServiceOperation_NotSupportedProtocolMethod = "ServiceOperation_NotSupportedProtocolMethod";
        internal const string ServiceOperation_DuplicateParameterName = "ServiceOperation_DuplicateParameterName";
        internal const string ServiceOperation_InvalidResultType = "ServiceOperation_InvalidResultType";
        internal const string ServiceOperation_InvalidReturnType = "ServiceOperation_InvalidReturnType";
        internal const string ServiceOperation_ActionBindingMustBeEntityOrEntityCollection = "ServiceOperation_ActionBindingMustBeEntityOrEntityCollection";
        internal const string ServiceOperation_BindableOperationMustHaveAtLeastOneParameter = "ServiceOperation_BindableOperationMustHaveAtLeastOneParameter";
        internal const string ServiceOperation_MustBeBindableToUsePathExpression = "ServiceOperation_MustBeBindableToUsePathExpression";
        internal const string ServiceOperation_BindingParameterMustBeEntityToUsePathExpression = "ServiceOperation_BindingParameterMustBeEntityToUsePathExpression";
        internal const string ServiceOperation_NonBindingParametersCannotBeEntityorEntityCollection = "ServiceOperation_NonBindingParametersCannotBeEntityorEntityCollection";
        internal const string Opereration_BoundOperationsMustNotSpecifyEntitySetOnlyEntitySetPath = "Opereration_BoundOperationsMustNotSpecifyEntitySetOnlyEntitySetPath";
        internal const string ServiceOperationParameter_TypeNotSupported = "ServiceOperationParameter_TypeNotSupported";
        internal const string SingleResourceExpected = "SingleResourceExpected";
        internal const string Syndication_ErrorReadingEntry = "Syndication_ErrorReadingEntry";
        internal const string Syndication_InvalidOpenPropertyType = "Syndication_InvalidOpenPropertyType";
        internal const string Syndication_InvalidOpenPropertyName = "Syndication_InvalidOpenPropertyName";
        internal const string ObjectContext_MissingExtendedAttributeType = "ObjectContext_MissingExtendedAttributeType";
        internal const string ObjectContext_ResourceTypeNameNotExist = "ObjectContext_ResourceTypeNameNotExist";
        internal const string ObjectContext_EntityTypeExpected = "ObjectContext_EntityTypeExpected";
        internal const string ObjectContext_ComplexTypeExpected = "ObjectContext_ComplexTypeExpected";
        internal const string ObjectContext_UnknownResourceTypeForClrType = "ObjectContext_UnknownResourceTypeForClrType";
        internal const string ObjectContext_PropertyNotDefinedOnType = "ObjectContext_PropertyNotDefinedOnType";
        internal const string ObjectContext_PublicPropertyNotDefinedOnType = "ObjectContext_PublicPropertyNotDefinedOnType";
        internal const string ObjectContext_PropertyMustBeNavigationProperty = "ObjectContext_PropertyMustBeNavigationProperty";
        internal const string ObjectContext_IfNoneMatchHeaderNotSupportedInUpdateAndDelete = "ObjectContext_IfNoneMatchHeaderNotSupportedInUpdateAndDelete";
        internal const string OperationWrapper_OperationResourceSetNotVisible = "OperationWrapper_OperationResourceSetNotVisible";
        internal const string OperationWrapper_TargetSetFromPathExpressionNotNotVisible = "OperationWrapper_TargetSetFromPathExpressionNotNotVisible";
        internal const string OperationWrapper_PathExpressionRequiresBindingSet = "OperationWrapper_PathExpressionRequiresBindingSet";
        internal const string ServiceOperationProvider_TypeIsAbstract = "ServiceOperationProvider_TypeIsAbstract";
        internal const string DataService_BatchExceedMaxBatchCount = "DataService_BatchExceedMaxBatchCount";
        internal const string DataService_BatchExceedMaxChangeSetCount = "DataService_BatchExceedMaxChangeSetCount";
        internal const string DataService_BatchResourceOnlySupportsPost = "DataService_BatchResourceOnlySupportsPost";
        internal const string DataService_ChangeInterceptorIncorrectParameterCount = "DataService_ChangeInterceptorIncorrectParameterCount";
        internal const string DataService_ContextTypeIsAbstract = "DataService_ContextTypeIsAbstract";
        internal const string DataService_CreateDataSourceNull = "DataService_CreateDataSourceNull";
        internal const string DataService_ExpandCountExceeded = "DataService_ExpandCountExceeded";
        internal const string DataService_QueryInterceptorIncorrectParameterCount = "DataService_QueryInterceptorIncorrectParameterCount";
        internal const string DataService_AttributeEntitySetNotFound = "DataService_AttributeEntitySetNotFound";
        internal const string DataService_AuthorizationMethodNotVoid = "DataService_AuthorizationMethodNotVoid";
        internal const string DataService_AuthorizationMethodVoid = "DataService_AuthorizationMethodVoid";
        internal const string DataService_AuthorizationParameterNotAssignable = "DataService_AuthorizationParameterNotAssignable";
        internal const string DataService_AuthorizationParameterNotResourceAction = "DataService_AuthorizationParameterNotResourceAction";
        internal const string DataService_AuthorizationReturnedNullQuery = "DataService_AuthorizationReturnedNullQuery";
        internal const string DataService_AuthorizationReturnTypeNotAssignable = "DataService_AuthorizationReturnTypeNotAssignable";
        internal const string DataService_HostNotAttached = "DataService_HostNotAttached";
        internal const string DataService_NotImplementedException = "DataService_NotImplementedException";
        internal const string DataService_ParameterIsOut = "DataService_ParameterIsOut";
        internal const string DataService_BothIfMatchAndIfNoneMatchHeaderSpecified = "DataService_BothIfMatchAndIfNoneMatchHeaderSpecified";
        internal const string DataService_ETagCannotBeSpecified = "DataService_ETagCannotBeSpecified";
        internal const string DataService_ETagSpecifiedForPost = "DataService_ETagSpecifiedForPost";
        internal const string DataService_ETagSpecifiedForServiceAction = "DataService_ETagSpecifiedForServiceAction";
        internal const string DataService_IfNoneMatchHeaderNotSupportedInDelete = "DataService_IfNoneMatchHeaderNotSupportedInDelete";
        internal const string DataService_IfNoneMatchHeaderNotSupportedInPut = "DataService_IfNoneMatchHeaderNotSupportedInPut";
        internal const string DataService_ETagNotSupportedInUnbind = "DataService_ETagNotSupportedInUnbind";
        internal const string DataService_CannotPerformOperationWithoutETag = "DataService_CannotPerformOperationWithoutETag";
        internal const string DataService_ContentIdMustBeAnInteger = "DataService_ContentIdMustBeAnInteger";
        internal const string DataService_ContentIdMustBeUniqueInBatch = "DataService_ContentIdMustBeUniqueInBatch";
        internal const string DataService_OnlyGetOperationSupportedOnServiceUrl = "DataService_OnlyGetOperationSupportedOnServiceUrl";
        internal const string DataService_VersionCannotBeParsed = "DataService_VersionCannotBeParsed";
        internal const string DataService_InvalidRequestVersion = "DataService_InvalidRequestVersion";
        internal const string DataService_DSVTooLow = "DataService_DSVTooLow";
        internal const string DataService_MaxDSVTooLow = "DataService_MaxDSVTooLow";
        internal const string DataService_RequestVersionMustBeLessThanMPV = "DataService_RequestVersionMustBeLessThanMPV";
        internal const string DataService_CannotUpdateKeyProperties = "DataService_CannotUpdateKeyProperties";
        internal const string DataService_ETagValueNotValid = "DataService_ETagValueNotValid";
        internal const string DataService_SDP_PageSizeWithMaxResultsPerCollection = "DataService_SDP_PageSizeWithMaxResultsPerCollection";
        internal const string DataService_SDP_PageSizeMustbeNonNegative = "DataService_SDP_PageSizeMustbeNonNegative";
        internal const string DataService_SDP_SkipTokenNotMatchingOrdering = "DataService_SDP_SkipTokenNotMatchingOrdering";
        internal const string DataService_SDP_TopLevelPagedResultWithOldExpandProvider = "DataService_SDP_TopLevelPagedResultWithOldExpandProvider";
        internal const string DataService_RegisterKnownTypeNotAllowedForIDSP = "DataService_RegisterKnownTypeNotAllowedForIDSP";
        internal const string DataService_Projections_ProjectionsWithOldExpandProvider = "DataService_Projections_ProjectionsWithOldExpandProvider";
        internal const string DataService_IDataServiceQueryProviderNull = "DataService_IDataServiceQueryProviderNull";
        internal const string DataService_CannotUpdateSetReferenceLinks = "DataService_CannotUpdateSetReferenceLinks";
        internal const string DataService_DerivedExpansions_OldExpandProvider = "DataService_DerivedExpansions_OldExpandProvider";
        internal const string ResourceAssociationSetEnd_ResourcePropertyMustBeNavigationPropertyOnResourceType = "ResourceAssociationSetEnd_ResourcePropertyMustBeNavigationPropertyOnResourceType";
        internal const string ResourceAssociationSetEnd_ResourceTypeMustBeAssignableToResourceSet = "ResourceAssociationSetEnd_ResourceTypeMustBeAssignableToResourceSet";
        internal const string ResourceAssociationSetEnd_ResourceTypeMustBeTheDeclaringType = "ResourceAssociationSetEnd_ResourceTypeMustBeTheDeclaringType";
        internal const string ResourceAssociationSet_ResourcePropertyCannotBeBothNull = "ResourceAssociationSet_ResourcePropertyCannotBeBothNull";
        internal const string ResourceAssociationSet_BidirectionalAssociationMustReturnSameResourceAssociationSetFromBothEnd = "ResourceAssociationSet_BidirectionalAssociationMustReturnSameResourceAssociationSetFromBothEnd";
        internal const string ResourceAssociationSet_SelfReferencingAssociationCannotBeBiDirectional = "ResourceAssociationSet_SelfReferencingAssociationCannotBeBiDirectional";
        internal const string ResourceAssociationSet_MultipleAssociationSetsForTheSameAssociationTypeMustNotReferToSameEndSets = "ResourceAssociationSet_MultipleAssociationSetsForTheSameAssociationTypeMustNotReferToSameEndSets";
        internal const string MetadataSerializer_NoResourceAssociationSetForNavigationProperty = "MetadataSerializer_NoResourceAssociationSetForNavigationProperty";
        internal const string MetadataSerializer_AccessEnabledTypeNoLongerExists = "MetadataSerializer_AccessEnabledTypeNoLongerExists";
        internal const string MetadataSerializer_ModelValidationErrors = "MetadataSerializer_ModelValidationErrors";
        internal const string DataServiceHost_EmptyHttpMethod = "DataServiceHost_EmptyHttpMethod";
        internal const string DataServiceHost_RequestHeadersCannotBeNull = "DataServiceHost_RequestHeadersCannotBeNull";
        internal const string DataServiceHost_ResponseHeadersCannotBeNull = "DataServiceHost_ResponseHeadersCannotBeNull";
        internal const string DataServiceHost_FeatureRequiresIDataServiceHost2 = "DataServiceHost_FeatureRequiresIDataServiceHost2";
        internal const string DataService_InvalidStreamFromGetWriteStream = "DataService_InvalidStreamFromGetWriteStream";
        internal const string DataService_InvalidStreamFromGetReadStream = "DataService_InvalidStreamFromGetReadStream";
        internal const string DataServiceConfiguration_NoChangesAllowed = "DataServiceConfiguration_NoChangesAllowed";
        internal const string DataServiceConfiguration_ResourceSetNameNotFound = "DataServiceConfiguration_ResourceSetNameNotFound";
        internal const string DataServiceConfiguration_ResourceTypeNameNotFound = "DataServiceConfiguration_ResourceTypeNameNotFound";
        internal const string DataServiceConfiguration_ServiceNameNotFound = "DataServiceConfiguration_ServiceNameNotFound";
        internal const string DataServiceConfiguration_NotComplexType = "DataServiceConfiguration_NotComplexType";
        internal const string DataServiceConfiguration_CountNotAccepted = "DataServiceConfiguration_CountNotAccepted";
        internal const string DataServiceConfiguration_ProjectionsNotAccepted = "DataServiceConfiguration_ProjectionsNotAccepted";
        internal const string DataServiceConfiguration_ResponseVersionIsBiggerThanProtocolVersion = "DataServiceConfiguration_ResponseVersionIsBiggerThanProtocolVersion";
        internal const string DataServiceException_GeneralError = "DataServiceException_GeneralError";
        internal const string DataServiceException_UnsupportedMediaType = "DataServiceException_UnsupportedMediaType";
        internal const string DataServiceHost_MoreThanOneQueryParameterSpecifiedWithTheGivenName = "DataServiceHost_MoreThanOneQueryParameterSpecifiedWithTheGivenName";
        internal const string WebUtil_ArgumentNullOrEmpty = "WebUtil_ArgumentNullOrEmpty";
        internal const string BadRequest_InvalidUriForPostOperation = "BadRequest_InvalidUriForPostOperation";
        internal const string BadRequest_InvalidUriForPutOperation = "BadRequest_InvalidUriForPutOperation";
        internal const string BadRequest_InvalidUriForPatchOperation = "BadRequest_InvalidUriForPatchOperation";
        internal const string BadRequest_InvalidUriForDeleteOperation = "BadRequest_InvalidUriForDeleteOperation";
        internal const string BadRequest_InvalidUriForMediaResource = "BadRequest_InvalidUriForMediaResource";
        internal const string BadRequest_NullRequestStream = "BadRequest_NullRequestStream";
        internal const string BadRequest_KeyCountMismatch = "BadRequest_KeyCountMismatch";
        internal const string BadRequest_CannotNullifyValueTypeProperty = "BadRequest_CannotNullifyValueTypeProperty";
        internal const string BadRequest_QueryOptionsShouldNotBeSpecifiedForDeletingSingleEntityReference = "BadRequest_QueryOptionsShouldNotBeSpecifiedForDeletingSingleEntityReference";
        internal const string BadRequest_IdMustBeSpecifiedForDeletingCollectionOfEntityReference = "BadRequest_IdMustBeSpecifiedForDeletingCollectionOfEntityReference";
        internal const string UpdatableWrapper_MissingIUpdatableForV1Provider = "UpdatableWrapper_MissingIUpdatableForV1Provider";
        internal const string UpdatableWrapper_MissingUpdateProviderInterface = "UpdatableWrapper_MissingUpdateProviderInterface";
        internal const string UpdatableWrapper_MustImplementDataServiceUpdateProvider2ToSupportServiceActions = "UpdatableWrapper_MustImplementDataServiceUpdateProvider2ToSupportServiceActions";
        internal const string InvalidUri_OpenPropertiesCannotBeCollection = "InvalidUri_OpenPropertiesCannotBeCollection";
        internal const string PropertyRequiresNonNegativeNumber = "PropertyRequiresNonNegativeNumber";
        internal const string DataServiceStreamProviderWrapper_MustImplementIDataServiceStreamProviderToSupportStreaming = "DataServiceStreamProviderWrapper_MustImplementIDataServiceStreamProviderToSupportStreaming";
        internal const string DataServiceStreamProviderWrapper_MustImplementDataServiceStreamProvider2ToSupportNamedStreams = "DataServiceStreamProviderWrapper_MustImplementDataServiceStreamProvider2ToSupportNamedStreams";
        internal const string DataServiceStreamProviderWrapper_MustNotSetContentTypeAndEtag = "DataServiceStreamProviderWrapper_MustNotSetContentTypeAndEtag";
        internal const string DataServiceStreamProviderWrapper_GetStreamContentTypeReturnsEmptyOrNull = "DataServiceStreamProviderWrapper_GetStreamContentTypeReturnsEmptyOrNull";
        internal const string DataServiceStreamProviderWrapper_GetReadStreamUriMustReturnAbsoluteUriOrNull = "DataServiceStreamProviderWrapper_GetReadStreamUriMustReturnAbsoluteUriOrNull";
        internal const string DataServiceStreamProviderWrapper_GetStreamETagReturnedInvalidETagFormat = "DataServiceStreamProviderWrapper_GetStreamETagReturnedInvalidETagFormat";
        internal const string DataServiceStreamProviderWrapper_ResolveTypeMustReturnValidResourceTypeName = "DataServiceStreamProviderWrapper_ResolveTypeMustReturnValidResourceTypeName";
        internal const string BadRequest_DeepRecursion = "BadRequest_DeepRecursion";
        internal const string BadRequest_DeepRecursion_General = "BadRequest_DeepRecursion_General";
        internal const string BadRequest_RequestUriDoesNotHaveTheRightBaseUri = "BadRequest_RequestUriDoesNotHaveTheRightBaseUri";
        internal const string BadRequest_RequestUriCannotBeBasedOnBaseUri = "BadRequest_RequestUriCannotBeBasedOnBaseUri";
        internal const string NoEmptyConstructorFoundForType = "NoEmptyConstructorFoundForType";
        internal const string CannotCreateInstancesOfAbstractType = "CannotCreateInstancesOfAbstractType";
        internal const string BadRequest_InvalidPropertyNameSpecified = "BadRequest_InvalidPropertyNameSpecified";
        internal const string BadRequest_DereferencingNullPropertyValue = "BadRequest_DereferencingNullPropertyValue";
        internal const string BadRequest_CannotSetCollectionsToNull = "BadRequest_CannotSetCollectionsToNull";
        internal const string BadRequest_ValuesCanBeReturnedForPrimitiveTypesOnly = "BadRequest_ValuesCanBeReturnedForPrimitiveTypesOnly";
        internal const string BadRequest_InvalidUriSpecified = "BadRequest_InvalidUriSpecified";
        internal const string BadRequest_DeepUpdateNotSupported = "BadRequest_DeepUpdateNotSupported";
        internal const string BadRequest_TypeInformationMustBeSpecifiedForInhertiance = "BadRequest_TypeInformationMustBeSpecifiedForInhertiance";
        internal const string BadRequest_ResourceCanBeCrossReferencedOnlyForBindOperation = "BadRequest_ResourceCanBeCrossReferencedOnlyForBindOperation";
        internal const string BadRequest_CannotSetTopLevelResourceToNull = "BadRequest_CannotSetTopLevelResourceToNull";
        internal const string BadRequest_MissingUriForLinkOperation = "BadRequest_MissingUriForLinkOperation";
        internal const string BadRequest_ErrorInSettingPropertyValue = "BadRequest_ErrorInSettingPropertyValue";
        internal const string BadRequest_PropertyValueCannotBeSet = "BadRequest_PropertyValueCannotBeSet";
        internal const string BadRequest_CannotUpdateRelatedEntitiesInPut = "BadRequest_CannotUpdateRelatedEntitiesInPut";
        internal const string BadRequest_ExceedsMaxObjectCountOnInsert = "BadRequest_ExceedsMaxObjectCountOnInsert";
        internal const string BadRequest_CollectionOfCollectionNotSupported = "BadRequest_CollectionOfCollectionNotSupported";
        internal const string BadRequest_CollectionTypeExpected = "BadRequest_CollectionTypeExpected";
        internal const string BadRequest_OpenCollectionProperty = "BadRequest_OpenCollectionProperty";
        internal const string CollectionCanOnlyBeEnumeratedOnce = "CollectionCanOnlyBeEnumeratedOnce";
        internal const string BadRequestStream_InvalidContent = "BadRequestStream_InvalidContent";
        internal const string BadRequest_InvalidTypeName = "BadRequest_InvalidTypeName";
        internal const string BadRequest_InvalidTypeSpecified = "BadRequest_InvalidTypeSpecified";
        internal const string BadRequestStream_MissingArrayMemberSeperator = "BadRequestStream_MissingArrayMemberSeperator";
        internal const string BadRequestStream_InvalidKeyword = "BadRequestStream_InvalidKeyword";
        internal const string BadRequestStream_MissingMemberName = "BadRequestStream_MissingMemberName";
        internal const string BadRequestStream_MissingMemberSeperator = "BadRequestStream_MissingMemberSeperator";
        internal const string BadRequestStream_MissingNameValueSeperator = "BadRequestStream_MissingNameValueSeperator";
        internal const string BadRequestStream_InvalidJsonNameSpecifiedOrExtraComma = "BadRequestStream_InvalidJsonNameSpecifiedOrExtraComma";
        internal const string BadRequestStream_InvalidJsonUnrecognizedEscapeSequence = "BadRequestStream_InvalidJsonUnrecognizedEscapeSequence";
        internal const string BadRequest_CannotSpecifyValueOrChildElementsForNullElement = "BadRequest_CannotSpecifyValueOrChildElementsForNullElement";
        internal const string BadRequest_LinkHrefMustReferToSingleResource = "BadRequest_LinkHrefMustReferToSingleResource";
        internal const string ObjectContext_DifferentContainerRights = "ObjectContext_DifferentContainerRights";
        internal const string ObjectContext_HasStreamAttributeEmpty = "ObjectContext_HasStreamAttributeEmpty";
        internal const string ObjectContext_NavigationPropertyUnbound = "ObjectContext_NavigationPropertyUnbound";
        internal const string ObjectContext_UnableToLoadMetadataForType = "ObjectContext_UnableToLoadMetadataForType";
        internal const string ObjectContext_UnsupportedStreamProperty = "ObjectContext_UnsupportedStreamProperty";
        internal const string ObjectContext_PrimitiveTypeNotSupported = "ObjectContext_PrimitiveTypeNotSupported";
        internal const string ReflectionProvider_MultipleEntitySetsForSameType = "ReflectionProvider_MultipleEntitySetsForSameType";
        internal const string ReflectionProvider_InvalidProperty = "ReflectionProvider_InvalidProperty";
        internal const string ReflectionProvider_EntityTypeHasKeyButNoEntitySet = "ReflectionProvider_EntityTypeHasKeyButNoEntitySet";
        internal const string ReflectionProvider_InvalidEntitySetProperty = "ReflectionProvider_InvalidEntitySetProperty";
        internal const string ReflectionProvider_EntityPropertyWithNoEntitySet = "ReflectionProvider_EntityPropertyWithNoEntitySet";
        internal const string ReflectionProvider_KeyPropertiesCannotBeIgnored = "ReflectionProvider_KeyPropertiesCannotBeIgnored";
        internal const string ReflectionProvider_ETagPropertyNameNotValid = "ReflectionProvider_ETagPropertyNameNotValid";
        internal const string ReflectionProvider_HasStreamAttributeOnlyAppliesToEntityType = "ReflectionProvider_HasStreamAttributeOnlyAppliesToEntityType";
        internal const string ReflectionProvider_ComplexTypeWithNavigationProperty = "ReflectionProvider_ComplexTypeWithNavigationProperty";
        internal const string ReflectionProvider_CollectionOfCollectionProperty = "ReflectionProvider_CollectionOfCollectionProperty";
        internal const string ReflectionProvider_CollectionOfUnsupportedTypeProperty = "ReflectionProvider_CollectionOfUnsupportedTypeProperty";
        internal const string ReflectionProvider_ResourceTypeHasNoPublicallyVisibleProperties = "ReflectionProvider_ResourceTypeHasNoPublicallyVisibleProperties";
        internal const string TargetElementTypeOfTheUriSpecifiedDoesNotMatchWithTheExpectedType = "TargetElementTypeOfTheUriSpecifiedDoesNotMatchWithTheExpectedType";
        internal const string ObjectContextServiceProvider_OSpaceTypeNotFound = "ObjectContextServiceProvider_OSpaceTypeNotFound";
        internal const string BadProvider_ResolveResourceReturnedNull = "BadProvider_ResolveResourceReturnedNull";
        internal const string BadProvider_CreateResourceReturnedNull = "BadProvider_CreateResourceReturnedNull";
        internal const string BadProvider_ResetResourceReturnedNull = "BadProvider_ResetResourceReturnedNull";
        internal const string BadProvider_InvalidTypeSpecified = "BadProvider_InvalidTypeSpecified";
        internal const string BadProvider_UnableToGetPropertyInfo = "BadProvider_UnableToGetPropertyInfo";
        internal const string BadProvider_UnsupportedType = "BadProvider_UnsupportedType";
        internal const string BadProvider_UnsupportedAncestorType = "BadProvider_UnsupportedAncestorType";
        internal const string BadProvider_UnsupportedPropertyType = "BadProvider_UnsupportedPropertyType";
        internal const string BadProvider_InconsistentEntityOrComplexTypeUsage = "BadProvider_InconsistentEntityOrComplexTypeUsage";
        internal const string BadProvider_UnknownResourceSet = "BadProvider_UnknownResourceSet";
        internal const string BadProvider_UnknownResourceType = "BadProvider_UnknownResourceType";
        internal const string BadProvider_ResourceTypeMustBeDeclaringTypeForProperty = "BadProvider_ResourceTypeMustBeDeclaringTypeForProperty";
        internal const string BadProvider_PropertyMustBeNavigationPropertyOnType = "BadProvider_PropertyMustBeNavigationPropertyOnType";
        internal const string AstoriaRequestMessage_CannotModifyRequestOrServiceUriAfterReadOnly = "AstoriaRequestMessage_CannotModifyRequestOrServiceUriAfterReadOnly";
        internal const string AstoriaRequestMessage_CannotChangeQueryString = "AstoriaRequestMessage_CannotChangeQueryString";
        internal const string DataServiceOperationContext_CannotModifyServiceUriInsideBatch = "DataServiceOperationContext_CannotModifyServiceUriInsideBatch";
        internal const string MetadataProviderUtils_UnsupportedPrimitiveTypeKind = "MetadataProviderUtils_UnsupportedPrimitiveTypeKind";
        internal const string MetadataProviderUtils_ConversionError = "MetadataProviderUtils_ConversionError";
        internal const string MetadataProviderUtils_PropertiesMustNotContainReservedChars = "MetadataProviderUtils_PropertiesMustNotContainReservedChars";
        internal const string MetadataProviderEdmModel_UnsupportedSchemaTypeKind = "MetadataProviderEdmModel_UnsupportedSchemaTypeKind";
        internal const string MetadataProviderEdmModel_UnsupportedResourceTypeKind = "MetadataProviderEdmModel_UnsupportedResourceTypeKind";
        internal const string MetadataProviderEdmModel_UnsupportedCollectionItemType_PrimitiveOrComplex = "MetadataProviderEdmModel_UnsupportedCollectionItemType_PrimitiveOrComplex";
        internal const string MetadataProviderEdmModel_UnsupportedCollectionItemType_EntityPrimitiveOrComplex = "MetadataProviderEdmModel_UnsupportedCollectionItemType_EntityPrimitiveOrComplex";
        internal const string MetadataProviderEdmModel_UnsupportedResourcePropertyKind = "MetadataProviderEdmModel_UnsupportedResourcePropertyKind";
        internal const string General_InternalError = "General_InternalError";
        internal const string ValueParser_InvalidDuration = "ValueParser_InvalidDuration";
        internal const string PlatformHelper_DateTimeOffsetMustContainTimeZone = "PlatformHelper_DateTimeOffsetMustContainTimeZone";

        static TextRes loader = null;
        ResourceManager resources;

        internal TextRes() {
            resources = new System.Resources.ResourceManager("Microsoft.OData.Service", this.GetType().Assembly);
        }

        private static TextRes GetLoader() {
            if (loader == null) {
                TextRes sr = new TextRes();
                Interlocked.CompareExchange(ref loader, sr, null);
            }
            return loader;
        }

        private static CultureInfo Culture {
            get { return null/*use ResourceManager default, CultureInfo.CurrentUICulture*/; }
        }

        public static ResourceManager Resources {
            get {
                return GetLoader().resources;
            }
        }

        public static string GetString(string name, params object[] args) {
            TextRes sys = GetLoader();
            if (sys == null)
                return null;
            string res = sys.resources.GetString(name, TextRes.Culture);

            if (args != null && args.Length > 0) {
                for (int i = 0; i < args.Length; i ++) {
                    String value = args[i] as String;
                    if (value != null && value.Length > 1024) {
                        args[i] = value.Substring(0, 1024 - 3) + "...";
                    }
                }
                return String.Format(CultureInfo.CurrentCulture, res, args);
            }
            else {
                return res;
            }
        }

        public static string GetString(string name) {
            TextRes sys = GetLoader();
            if (sys == null)
                return null;
            return sys.resources.GetString(name, TextRes.Culture);
        }

        public static string GetString(string name, out bool usedFallback) {
            // always false for this version of gensr
            usedFallback = false;
            return GetString(name);
        }

        public static object GetObject(string name) {
            TextRes sys = GetLoader();
            if (sys == null)
                return null;
            return sys.resources.GetObject(name, TextRes.Culture);
        }
    }
}
